dojo.provide("com.ibm.btools.blm.businesstools.rest.RibbonContributor");

dojo.require("com.ibm.busleader.widgets.documenteditor.view.extension.ribbon.IRibbonContributor");
dojo.require("com.ibm.busleader.widgets.documenteditor.view.extension.ribbon.RibbonButtonVisualInfo");
dojo.require("dojo.i18n");

dojo.declare("com.ibm.btools.blm.businesstools.rest.RibbonContributor", [com.ibm.busleader.widgets.documenteditor.view.extension.ribbon.IRibbonContributor],{

	messages : null,
	
	constructor : function(){
		dojo.requireLocalization("com.ibm.btools.blm.businesstools.rest", "CommonResources");
		this.messages = dojo.i18n.getLocalization("com.ibm.btools.blm.businesstools.rest", "CommonResources");
	},

	getSectionName : function() {
		return this.messages.sectionName;
	},
	
	/**
	 * Must return an array of strings, representing the (ribbon-wide) unique ID to use for each button 
	 */
	getButtonIds : function() {
		console.debug("RibbonContributor.getButtonIds()");
		return ["button1"];
	},

	/**
	 * Returns an instance of RibbonButtonVisualInfo that describes the icon and labels to use
	 * for each button in the ribbon section.
	 */
	getVisualInfo : function(buttonId) {
		console.debug("RibbonContributor.getVisualInfo(): buttonId = %o", buttonId);
		var vi = new com.ibm.busleader.widgets.documenteditor.view.extension.ribbon.RibbonButtonVisualInfo();
		vi.buttonLabel = (buttonId == "button1" ? this.messages.transformButtonLabel : "Button 2");
		vi.tooltipLabel = this.messages.transformButtonToolTip;
		
		vi.buttonIconURL_big_enabled = "/com/ibm/btools/blm/businesstools/rest/images/convertomodeler.png";
		vi.buttonIconURL_big_disabled = "/com/ibm/btools/blm/businesstools/rest/images/convertomodeler_dsbl.png";
		vi.buttonIconURL_small_enabled = "/com/ibm/btools/blm/businesstools/rest/images/trans_mod.png";
		vi.buttonIconURL_small_disabled = "/com/ibm/btools/blm/businesstools/rest/images/trans_mod_dsbl.png";
		
		var viStr = dojo.toJson(vi);
		
		console.debug("RibbonContainer.getVisualInfo(): viStr = %o", viStr);
		return viStr;
	},
	
	/**
	 * Returns true or false depending on whether the button section should be included in the ribbon 
	 * for editors of the given document type
	 */
	isApplicableForDocumentType : function(documentType) {
		console.debug("RibbonContainer.isApplicableForDocumentType(): documentType = %o", documentType);
		return true;
	},
	
	/**
	 * Returns true or false depending on whether the button section should be included in the ribbon 
	 * for editors that are in the given documentModel.  Possible values are "VIEW" and "EDIT".
	 */
	isApplicableForDocumentMode : function(documentMode) {
		console.debug("RibbonContainer.isApplicableForDocumentMode(): documentMode = %o", documentMode);
		return true;
	},
	
	/**
	 * Returns true or false depending on whether the button with the given ID should be 
	 * enabled given the documentUUID and the elements that are currently selected in the editor
	 */
	isEnabled: function(buttonId, documentUUID, selectedElementUUIDs) {
		console.debug("RibbonContainer.isEnabled(): buttonId = %o, documentUUID = %o, selectedElementUUIDs = %o", buttonId, documentUUID, selectedElementUUIDs);
		return true;
	},
	
	/**
	 * Executes the action represented by the button with the given ID  
	 * given the context of the documentUUID and the elements that are currently selected in the editor
	 */
	execute : function(buttonId, documentUUID, selectedElementUUIDs) {
		console.debug("RibbonContainer.execute(): buttonId = %o, documentUUID = %o, selectedElementUUIDs = %o", buttonId, documentUUID, selectedElementUUIDs);

		// update status line to communicate with Modeler
		window.status = "PushToModelerProject" + "*" + documentUUID + "*" + selectedElementUUIDs;
		window.status = " ";
	}
	
});
